{mik 12/12/97, modified from winroll of Sean Hsieh, in love with MakeObjectInstance call,
can do otherway but this is the best}
unit TQuestn;

interface

uses
  wintypes, winprocs,Messages, SysUtils, Classes, Graphics, Controls, Forms, ExtCtrls;
const counter : byte = 0;
type
 TShapes = (sSquare, striangle,sEllipse);
  TQuestion = class(TComponent)
  private
    DefWinProc: TFarProc;
    DefWinProcInstance: Pointer;
    FShape : Tshapes;
    Rect: TRect;
    Pushed: Boolean;
    FOnFormDestroy: TNotifyEvent;
    FOnclick :  tnotifyevent;
    procedure CalcArea;
    procedure OnButtonDestroy( Sender: TObject );
    procedure PaintButton;
    procedure SetEnabled( Val: Boolean );
    procedure WinProc(var Message: TMessage);
  public
    constructor Create(Owner: TComponent); override;
    destructor Destroy; override;
  published
    property Onclick: Tnotifyevent read Fonclick write Fonclick;
    Property Shape :Tshapes read fshape write fshape;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Custom', [Tquestion]);
end;

constructor Tquestion.Create(Owner: TComponent);
begin
  inherited create(Owner);
  inc(counter);
  if counter > 1 then
  begin
    dec(counter);
    raise exception.Create('Single instance control');
  end;
  Pushed := False;
  if not (Owner is TForm) then
    raise exception.Create('Owner must be a Tform');
  with TForm(Owner) do
  if not (csDesigning in ComponentState) then
  begin
    DefWinProcInstance := MakeObjectInstance(WinProc);
    DefWinProc := Pointer(SetWindowLong(Handle, GWL_WNDPROC, Longint(DefWinProcInstance)));
    CalcArea;
    FOnFormDestroy := OnDestroy;
    OnDestroy := OnButtonDestroy;
  end;
end;

destructor Tquestion.Destroy;
begin
  if not (csDesigning in ComponentState) and assigned(DefWinProcInstance) then
  begin
    SetWindowLong(TForm(Owner).Handle, GWL_WNDPROC, Longint(DefWinProc));
    FreeObjectInstance(DefWinProcInstance);
    DefWinProcInstance := nil;
  end;
  inherited destroy;
end;

procedure Tquestion.OnButtonDestroy( Sender: TObject );
begin
  if Assigned( FOnFormDestroy ) then
    FOnFormDestroy( Sender );
  SetWindowLong(TForm(Owner).Handle, GWL_WNDPROC, Longint(DefWinProc));
  FreeObjectInstance(DefWinProcInstance);
  DefWinProcInstance := nil;
end;

procedure Tquestion.CalcArea;
var
  x1, y1, x2, y2, w: Integer;
  Icons: TBorderIcons;
  Style: TFormBorderStyle;
begin
  with TForm(Owner) do
  begin
    if csDesigning in ComponentState then
    begin
      Icons := [biSystemMenu, biMinimize, biMaximize];
      Style := bsSizeable;
    end
    else
    begin
      Icons := BorderIcons;
      Style := BorderStyle;
    end;
  end;
   if Style in [bsSingle, bsSizeable, bsDialog] then
    begin
      if Style = bsSingle then
        x2 := GetSystemMetrics(SM_CYFRAME) + 2
      else
        x2 := GetSystemMetrics(SM_CXFRAME) + 2;
      if biSystemMenu in Icons then
      begin
        Inc(x2, GetSystemMetrics(SM_CXSIZE) + 2);
        if (Style <> bsDialog) and (Icons * [biMinimize, biMaximize] <> []) then
          Inc(x2, GetSystemMetrics(SM_CXSIZE) * 2 - 6)
      end;
      if Style in [bsSingle, bsDialog] then
        y1 := GetSystemMetrics(SM_CYFRAME) + 2
      else
        y1 := GetSystemMetrics(SM_CYFRAME) + 2;
      y2 := y1 + GetSystemMetrics(SM_CYSIZE) - 4;
      x2 := TForm(Owner).Width - x2;
      x1 := (x2 - (GetSystemMetrics(SM_CXSIZE) + 2) * counter);
    end;
  SetRect(Rect, x1, y1, x2-1, y2-1);
end;

procedure Tquestion.PaintButton;
var
  h: HDC;
  b: HBRUSH;
  pen: HPEN;
  F : HFONT;
begin
  if not (csDesigning in ComponentState) then
    if not (TForm(Owner).BorderStyle = bsNone) then
      begin
          h := GetWindowDC( TForm(Owner).Handle );
          b := CreateSolidBrush( GetSysColor( COLOR_BTNFACE ) );
          pen := createpen(ps_solid,1,BLACK_PEN );
          pen := SelectObject( h, GetStockObject( WHITE_PEN ) );
         if Pushed then
          pen := SelectObject( h, GetStockObject( BLACK_PEN) );
case fshape of
sEllipse: begin
     with RECT do
     begin
        b := SelectObject( h, GetStockObject(1));
        ellipse(h,left+2,top,right -1,bottom-1);
        pen := SelectObject( h, GetStockObject( WHITE_PEN) );
        if Pushed then
        begin
         pen := SelectObject( h, GetStockObject( BLACK_PEN ) );
         Arc(H,left+1,top+1,RIGHT-1,BOTTOM,RIGHT div 5 * 4,BOTTOM div 5,RIGHT div 5,BOTTOM div 5 * 4);
        end
        else
          Arc(H,left,top,RIGHT-1,BOTTOM,RIGHT div 5 * 4,BOTTOM div 5,RIGHT div 5,BOTTOM div 5 * 4);
         pen := SelectObject( h, GetStockObject( BLACK_PEN ) );
        if Pushed then
         pen := SelectObject( h, GetStockObject( WHITE_PEN ) );
        Arc(H,left,top,RIGHT-1,BOTTOM,RIGHT div 5,BOTTOM div 5 * 4,RIGHT div 5 * 4,BOTTOM div 5);
      end;
      END;
 else begin
         with Rect do
          begin
           FillRect( h, Rect, b );
           moveto(h,left, bottom );
           lineto(h,left , top );
           lineto(h,right,top);
           pen := SelectObject( h, GetStockObject( BLACK_PEN) );
           if Pushed then
            pen := SelectObject( h, GetStockObject( WHITE_PEN ) );
           lineto(h,right, bottom );
           lineto(h,left , bottom);
          end;
        end;
  end; {case}
          F := SelectObject( h, GetStockObject(SYSTEM_FONT));
          SETBKCOLOR(H,COLOR_BTNFACE);
          SETTEXTCOLOR(H,CLBLACK);
          SETBKMODE(H,TRANSPARENT	);
          if pushed then
          winprocs .Textout(h, ((Rect.Right+Rect.Left) DIV 2) - 4, 5, '?',1)
          else
          winprocs .Textout(h, ((Rect.Right+Rect.Left) DIV 2) - 5, 4, '?',1);
          DeleteObject( b );
          DeleteObject( pen );
          DeleteObject( F );
        end;
        ReleaseDC(TForm(Owner).Handle, h );
end;

procedure Tquestion.SetEnabled( Val: Boolean );
begin
end;


procedure Tquestion.WinProc(var Message: TMessage);
  procedure Default;
  begin
    with Message do
      Result := CallWindowProc(DefWinProc, TForm(Owner).Handle, Msg, wParam, lParam);
  end;

  function InArea( InClient: Boolean ): Boolean;
  var
    p: TPoint;
  begin
    p.x := Message.lParamLo;
    p.y := Smallint(Message.lParamHi);
    if InClient then
      winprocs .ClientToScreen( TForm(Owner).Handle, p );
    Dec( p.x, TForm(Owner).Left );
    Dec( p.y, TForm(Owner).Top );
    Result := PtInRect( Rect, p );
  end;

begin

  with Message do
    case Msg of
      WM_MOVE:
      begin
        Default;
      end;
      WM_SIZE, WM_WINDOWPOSCHANGED:
      begin
        Default;
        PaintButton;
        CalcArea;
        PaintButton;
      end;
      WM_LBUTTONUP, WM_LBUTTONDBLCLK:
      begin
        Pushed := False;
          if InArea( True ) then
            PaintButton
        else
          Result := 1;
          Default;
        ReleaseCapture;
        if assigned(FOnclick) then
          FOnclick(self);
        PaintButton;
      end;
      WM_NCLBUTTONDOWN, WM_NCLBUTTONDBLCLK:
      begin
        if InArea( False ) then
        begin
          SetCapture( TForm(Owner).Handle );
          Pushed := True;
          PaintButton;
          Result := 1;
        end;
        if Msg = WM_NCLBUTTONDOWN then
          Default;
      end;
      WM_NCACTIVATE, WM_NCPAINT:
      begin
        Default;
        PaintButton;
      end;
      else
        Default;
    end;
end;

end.
